# concurrency-demo

I want to practice using async, stm libraries to solve real world problems.

## problem: Dining philosophers problem

https://en.wikipedia.org/wiki/Dining_philosophers_problem

Five silent philosophers sit at a round table with bowls of spaghetti. Forks
are placed between each pair of adjacent philosophers.

Each philosopher must alternately think and eat. However, a philosopher can
only eat spaghetti when they have both left and right forks. Each fork can be
held by only one philosopher and so a philosopher can use the fork only if it
is not being used by another philosopher. After an individual philosopher
finishes eating, they need to put down both forks so that the forks become
available to others. A philosopher can take the fork on their right or the one
on their left as they become available, but cannot start eating before getting
both forks.

Eating is not limited by the remaining amounts of spaghetti or stomach space;
an infinite supply and an infinite demand are assumed.

The problem is how to design a discipline of behavior (a concurrent algorithm)
such that no philosopher will starve; i.e., each can forever continue to
alternate between eating and thinking, assuming that no philosopher can know
when others may want to eat or think.

## problem: Elevator simulator

Design an elevator which allows concurrent user input.

feature request:
- elevator requires time to accelerate and slow down
- elevator have a maximum capacity
- user can press Up/Down button at any level
- there can be any number of user at each floor
- user have normal behavior.
  - they don't stay in elevator forever
  - they press target floor when they are in
  - they leave when target floor is arrived
- a GUI is of much help for visualizing this system.
- when total floor is high, there are buttons that allow user to press which
  floor they want to go, to help elevator scheduling stops.
- 
