module Lib where

import System.Random (randomRIO)
import Control.Concurrent (threadDelay)

-- | return microseconds between [0, 5s]
randomMicroseconds :: IO Int
randomMicroseconds = randomRIO (0, 5 * 1000000)

think :: String -> IO ()
think name = do
  putStrLn $ "Philosopher " ++ name ++ " is thinking"
  delayAmout <- randomMicroseconds
  threadDelay delayAmout

eat :: String -> IO ()
eat name = do
  putStrLn $ "Philosopher " ++ name ++ " is eating"
  delayAmout <- randomMicroseconds
  threadDelay delayAmout
